<?php

namespace Drupal\purest_menus\Normalizer;

use Drupal\serialization\Normalizer\NormalizerBase;
use Drupal\Component\Utility\UrlHelper;

/**
 * MenuLinkTreeElement Normalizer.
 */
class MenuLinkNormalizer extends NormalizerBase {
  protected $supportedInterfaceOrClass = 'Drupal\Core\Menu\MenuLinkInterface';

  /**
   * {@inheritdoc}
   */
  public function normalize($object, $format = NULL, array $context = []) {
    $uuid = $object->getDerivativeId();
    $entity = \Drupal::service('entity.repository')
      ->loadEntityByUuid('menu_link_content', $uuid);
    $url = $object->getUrlObject()->toString();

    return [
      'title' => $object->getTitle(),
      'url' => $url,
      'external' => UrlHelper::isExternal($url)
    ];
  }
}
