<?php

namespace Drupal\purest_menus\Normalizer;

use Drupal\serialization\Normalizer\NormalizerBase;

/**
 * MenuLinkTreeElement Normalizer.
 */
class MenuLinkTreeNormalizer extends NormalizerBase {
  
  protected $supportedInterfaceOrClass = 'Drupal\Core\Menu\MenuLinkTreeElement';

  /**
   * {@inheritdoc}
   */
  public function normalize($object, $format = NULL, array $context = []) {
    $link = $this->serializer->normalize($object->link, $format, $context);

    return $link += [
      'in_active_trail' => $object->inActiveTrail,
      'has_children' => $object->hasChildren,
      'children' => $this->serializer->normalize($object->subtree, $format, $context),
    ];
  }
}
