<?php

namespace Drupal\purest\Normalizer;

use Drupal\metatag\Normalizer\MetatagNormalizer;

/**
 * Normalizes metatag into the viewed entity.
 */
class SchemaMetatagNormalizer extends MetatagNormalizer {

  /**
   * {@inheritdoc}
   */
  protected $supportedInterfaceOrClass = 'Drupal\metatag\Plugin\Field\MetatagEntityFieldItemList';

  /**
   * {@inheritdoc}
   */
  public function normalize($field_item, $format = NULL, array $context = []) {
    // @see metatag_get_tags_from_route()
    $entity = $field_item->getEntity();

    $tags = metatag_get_tags_from_route($entity);

    $normalized['value'] = [];
    if (isset($tags['#attached']['html_head'])) {
      foreach ($tags['#attached']['html_head'] as $tag) {
        // @todo Work out a proper, long-term fix for this.
        if (isset($tag[0]['#attributes']['content'])) {
          $normalized[$tag[1]] = $tag[0]['#attributes']['content'];
        }
        else if (isset($tag[0]['#attributes']['href'])) {
          $normalized[$tag[1]] = $tag[0]['#attributes']['href'];
        }
      }
    }

    if (isset($context['langcode'])) {
      $normalized['lang'] = $context['langcode'];
    }

    return $normalized;
  }

  /**
   * {@inheritdoc}
   */
  public function supportsDenormalization($data, $type, $format = NULL) {
    return FALSE;
  }

}
